Index: Dutch.php
===================================================================
--- Dutch.php	(revision 8843)
+++ Dutch.php	(working copy)
@@ -14,62 +14,62 @@
 // Warning, any custom comments will be lost during translation updates.
 //
 // Shared Terms
-    '$1 Search'                                          => '',
+    '$1 Search'                                          => '$1 Zoeken',
     '$1 hr'                                              => '$1 uur',
     '$1 hrs'                                             => '$1 uur',
     '$1 min'                                             => '$1 min',
     '$1 mins'                                            => '$1 min',
     '$1 programs, using $2 ($3) out of $4 ($5 free).'    => '$1 programma\'s, U gebruikt $2 ($3) van $4.',
     '$1 to $2'                                           => '$1 tot $2',
-    'Activate'                                           => 'Activeer',
+    'Activate'                                           => 'Activeren',
     'Advanced Options'                                   => 'Geavanceerde Opties',
     'Airtime'                                            => 'Uitzendtijd',
     'All recordings'                                     => 'Alle opnames',
     'Auto-expire recordings'                             => 'Opnames Autom. Vervallen',
     'Auto-flag commercials'                              => 'Reclame Autom. Markeren',
-    'Auto-transcode'                                     => '',
-    'Backend Logs'                                       => '',
+    'Auto-transcode'                                     => 'Auto-transcode',
+    'Backend Logs'                                       => 'Backend Logboek',
     'Backend Status'                                     => 'Backend Status',
-    'Cancel this schedule.'                              => 'Annuleer deze opname',
+    'Cancel this schedule.'                              => 'Opname annuleren',
     'Category'                                           => 'Categorie',
-    'Check for duplicates in'                            => 'Controleer op dubbels in',
-    'Create Schedule'                                    => 'Maak Schema',
+    'Check for duplicates in'                            => 'Op dubbels controleren in',
+    'Create Schedule'                                    => 'Opname plannen',
     'Current recordings'                                 => 'Huidige Opnames',
     'Currently Browsing:  $1'                            => 'Tijdstip: $1',
-    'Custom Schedule'                                    => '',
+    'Custom Schedule'                                    => 'Geavanceerde Opname',
     'Date'                                               => 'Datum',
     'Default'                                            => 'Standaard',
     'Description'                                        => 'Beschrijving',
-    'Details for'                                        => '',
-    'Display'                                            => 'Toon',
+    'Details for'                                        => 'Details',
+    'Display'                                            => 'Tonen',
     'Don\'t Record'                                      => 'Niet Opnemen',
     'Duplicate Check method'                             => 'Testmethode herh.',
     'End Late'                                           => 'Later stoppen',
     'Episode'                                            => 'Aflevering',
-    'Forget Old'                                         => 'Vergeet Oude',
+    'Forget Old'                                         => 'Oude vergeten',
     'Friday'                                             => 'Vrijdag',
     'Hour'                                               => 'Uur',
     'IMDB'                                               => 'IMDB',
-    'Inactive'                                           => '',
+    'Inactive'                                           => 'Niet actief',
     'Jump'                                               => 'Ga',
-    'Jump to'                                            => 'Spring naar',
-    'Keyword'                                            => '',
+    'Jump to'                                            => 'Ga naar',
+    'Keyword'                                            => 'Kernwoord',
     'Listings'                                           => 'Programmagids',
     'Monday'                                             => 'Maandag',
-    'Music'                                              => '',
+    'Music'                                              => 'Muziek',
     'Never Record'                                       => 'Nooit Opnemen',
-    'No'                                                 => 'Nee',
+    'No'                                                 => 'Neen',
     'No. of recordings to keep'                          => 'Aantal opnames bewaren',
     'None'                                               => 'Geen',
     'Only New Episodes'                                  => 'Enkel Nieuwe Afleveringen',
     'Original Airdate'                                   => 'Oorsp. Datum',
-    'People'                                             => '',
+    'People'                                             => 'Personen',
     'Power'                                              => '',
     'Previous recordings'                                => 'Eerdere opnames',
-    'Program Listing'                                    => '',
+    'Program Listing'                                    => 'Programmalijst',
     'Rating'                                             => 'Beoordeling',
     'Record This'                                        => 'Dit Opnemen',
-    'Record new and expire old'                          => 'Neem nieuwe op, wis oude',
+    'Record new and expire old'                          => 'Nieuwe opnemen en oude wissen',
     'Recorded Programs'                                  => 'Opgenomen Programma\'s',
     'Recording Group'                                    => 'Opname Groep',
     'Recording Options'                                  => 'Opname Opties',
@@ -79,30 +79,30 @@
     'Repeat'                                             => 'Opnieuw Uitvoeren',
     'Saturday'                                           => 'Zaterdag',
     'Save'                                               => 'Opslaan',
-    'Save Schedule'                                      => '',
-    'Schedule'                                           => 'Programmeer',
-    'Schedule Manually'                                  => '',
+    'Save Schedule'                                      => 'Schema opslaan',
+    'Schedule'                                           => 'Programmeren',
+    'Schedule Manually'                                  => 'Handmatig',
     'Schedule Options'                                   => 'Schema Opties',
     'Schedule Override'                                  => 'Aangepast Schema',
     'Schedule normally.'                                 => 'Normaal Schema',
     'Search'                                             => 'Zoeken',
     'Search Results'                                     => 'Zoekresultaten',
     'Settings'                                           => 'Instellingen',
-    'Start Early'                                        => 'Eerder Beginnen',
+    'Start Early'                                        => 'Eerder beginnen',
     'Subtitle'                                           => 'Aflevering',
-    'Subtitle and Description'                           => 'Aflevering en Beschrijving',
+    'Subtitle and Description'                           => 'Aflevering en beschrijving',
     'Sunday'                                             => 'Zondag',
     'The requested recording schedule has been deleted.' => 'Het gevraagde opnameschema is verwijderd',
     'Thursday'                                           => 'Donderdag',
     'Title'                                              => 'Titel',
-    'Transcoder'                                         => '',
+    'Transcoder'                                         => 'Transcoder',
     'Tuesday'                                            => 'Dinsdag',
     'Type'                                               => 'Type',
     'Unknown'                                            => 'Onbekend',
-    'Upcoming Recordings'                                => '',
-    'Update'                                             => 'Pas Aan',
+    'Upcoming Recordings'                                => 'Geplande Opnames',
+    'Update'                                             => 'Aanpassen',
     'Update Recording Settings'                          => 'Opname-instellingen Vernieuwen',
-    'Weather'                                            => '',
+    'Weather'                                            => 'Weer',
     'Wednesday'                                          => 'Woensdag',
     'Yes'                                                => 'Ja',
     'airdate'                                            => 'uitzenddatum',
@@ -113,56 +113,56 @@
     'length'                                             => 'duur',
     'minutes'                                            => 'minuten',
     'recgroup'                                           => 'opnamegroep',
-    'recpriority'                                        => '',
-    'rectype-long: always'                               => 'Dit programma altijd op elke zender opnemen.',
-    'rectype-long: channel'                              => 'Dit programma altijd op deze zender opnemen.',
-    'rectype-long: daily'                                => 'Dit programma dagelijks in dit tijdsslot opnemen.',
-    'rectype-long: dontrec'                              => 'Dit programma niet opnemen',
-    'rectype-long: finddaily'                            => 'Vind dagelijks een uitzending van dit programma',
-    'rectype-long: findone'                              => 'Vind 1 uitzending van dit programma en neem op.',
-    'rectype-long: findweekly'                           => 'Vind wekelijks een opname van dit programma',
-    'rectype-long: once'                                 => 'Dit programma eenmalig opnemen.',
+    'recpriority'                                        => 'opnameprioriteit',
+    'rectype-long: always'                               => 'Altijd op elke zender opnemen.',
+    'rectype-long: channel'                              => 'Altijd op deze zender opnemen.',
+    'rectype-long: daily'                                => 'Dagelijks in dit tijdsslot opnemen.',
+    'rectype-long: dontrec'                              => 'Niet opnemen',
+    'rectype-long: finddaily'                            => 'Dagelijks een uitzending opnemen',
+    'rectype-long: findone'                              => '1 uitzending opnemen',
+    'rectype-long: findweekly'                           => 'Wekelijks een uitzending opnemen',
+    'rectype-long: once'                                 => 'Deze uitzending opnemen.',
     'rectype-long: override'                             => 'Aangepaste opties',
-    'rectype-long: weekly'                               => 'Dit programma wekelijks in dit tijdsslot opnemen.',
+    'rectype-long: weekly'                               => 'Wekelijks in dit tijdsslot opnemen.',
     'rectype: always'                                    => 'Altijd',
     'rectype: channel'                                   => 'Zender',
     'rectype: daily'                                     => 'Dagelijks',
     'rectype: dontrec'                                   => 'Niet Opnemen',
-    'rectype: findone'                                   => 'Vind Eén',
-    'rectype: once'                                      => 'Eenmalig',
+    'rectype: findone'                                   => '1 Opnemen',
+    'rectype: once'                                      => 'Deze',
     'rectype: override'                                  => 'Aangepast (opname)',
     'rectype: weekly'                                    => 'Wekelijks',
     'subtitle'                                           => 'aflevering',
     'title'                                              => 'titel',
 // config/canned_searches.php
-    'All HDTV'                           => '',
-    'Movies'                             => '',
-    'Movies, 3&frac12; Stars or more'    => '',
-    'Movies, Stinkers (2 Stars or less)' => '',
-    'Music Specials'                     => '',
-    'New Titles, Premieres'              => '',
-    'Non-Music Specials'                 => '',
-    'Non-Series HDTV'                    => '',
-    'Science Fiction Movies'             => '',
+    'All HDTV'                           => 'Alle HDTV',
+    'Movies'                             => 'Films',
+    'Movies, 3&frac12; Stars or more'    => 'Films, 3&frac12; sterren of meer',
+    'Movies, Stinkers (2 Stars or less)' => 'Films, Stinkers (2 sterren of minder)',
+    'Music Specials'                     => 'Muziek Specials',
+    'New Titles, Premieres'              => 'Nieuwe Titels, Premieres',
+    'Non-Music Specials'                 => 'Niet-Muziek Specials',
+    'Non-Series HDTV'                    => 'HDTV, geen series',
+    'Science Fiction Movies'             => 'Science Fiction Films',
 // includes/programs.php
-    'CC'                           => '',
-    'HDTV'                         => '',
+    'CC'                           => 'OND',
+    'HDTV'                         => 'HDTV',
     'Notes'                        => 'Opmerkingen',
-    'Part $1 of $2'                => '',
-    'Stereo'                       => '',
-    'Subtitled'                    => '',
+    'Part $1 of $2'                => 'Deel $1 van $2',
+    'Stereo'                       => 'Stereo',
+    'Subtitled'                    => 'Ondertiteld',
     'recstatus: cancelled'         => 'Dit programma zou opgenomen worden maar werd handmatig geannuleerd',
     'recstatus: conflict'          => 'Een ander programma met hogere prioriteit zal opgenomen worden',
     'recstatus: currentrecording'  => 'Dit programma werd eerder opgenomen en bevindt zich nog in de lijst met opgenomen programma\'s',
     'recstatus: deleted'           => 'Dit programma werd opgenomen maar werd al verwijderd voor de opname afgelopen was.',
     'recstatus: earliershowing'    => 'Dit programma wordt op een vroegere tijd opgenomen.',
     'recstatus: force_record'      => 'Dit programma werd handmatig ingesteld op deze manier opgenomen te worden.',
-    'recstatus: inactive'          => '',
+    'recstatus: inactive'          => 'Dit opnameschema is niet actief',
     'recstatus: latershowing'      => 'Dit programma zal op een later tijdstip opgenomen worden.',
     'recstatus: lowdiskspace'      => 'Er was niet voldoende schijfruimte aanwezig om dit programma op te nemen.',
     'recstatus: manualoverride'    => 'Dit werd handmatig ingesteld niet opgenomen te worden.',
-    'recstatus: neverrecord'       => '',
-    'recstatus: notlisted'         => '',
+    'recstatus: neverrecord'       => 'Dit programma werd ingesteld nooit opgenomen te wordem',
+    'recstatus: notlisted'         => 'Dit programa komt niet overeen met de programmagids',
     'recstatus: previousrecording' => 'Dit programma werd eerder opgenomen volgens de regels die gekozen werden voor het detecteren van dubbels.',
     'recstatus: recorded'          => 'Dit programma werd opgenomen.',
     'recstatus: recording'         => 'Dit programma wordt nu opgenomen.',
@@ -176,8 +176,8 @@
     'Dup Method'                   => 'Dubbels Methode',
     'Profile'                      => 'Profiel',
     'Sub and Desc (Empty matches)' => 'Dubbels en Beschrijving',
-    'rectype: finddaily'           => 'Vind een dagelijkse uitzending.',
-    'rectype: findweekly'          => 'Vind een wekelijkse uitzending.',
+    'rectype: finddaily'           => 'Dagelijkse een uitzending opnemen.',
+    'rectype: findweekly'          => 'Wekelijkse een uitzending opnemen.',
 // includes/utils.php
     '$1 B'  => '$1 B',
     '$1 GB' => '$1 GB',
@@ -185,51 +185,51 @@
     '$1 MB' => '$1 MB',
     '$1 TB' => '$1 TB',
 // modules/backend_log/init.php
-    'Logs' => '',
+    'Logs' => 'Logboek',
 // modules/movietimes/init.php
-    'Movie Times' => '',
+    'Movie Times' => 'Bioscoop Tijden',
 // modules/settings/init.php
-    'MythTV channel info'      => '',
-    'MythTV key bindings'      => '',
-    'MythWeb session settings' => '',
-    'settings'                 => '',
+    'MythTV channel info'      => 'MythTV zenderinfo',
+    'MythTV key bindings'      => 'MythTV toetsbindingen',
+    'MythWeb session settings' => 'MythWeb sessie instellingen',
+    'settings'                 => 'instellingen',
 // modules/status/init.php
-    'Status' => '',
+    'Status' => 'Status',
 // modules/stream/init.php
-    'Streaming' => '',
+    'Streaming' => 'Stroom aan het doorsturen',
 // modules/tv/detail.php
-    'This program is already scheduled to be recorded via a $1custom search$2.' => '',
+    'This program is already scheduled to be recorded via a $1custom search$2.' => 'Dit programma is al ingesteld opgenomen te worden via $1custom search$2',
     'Unknown Program.'                                                          => 'Onbekend Programma.',
     'Unknown Recording Schedule.'                                               => 'Onbekend Opnameschema',
 // modules/tv/init.php
-    'Special Searches' => '',
-    'TV'               => '',
+    'Special Searches' => 'Speciaal zoeken',
+    'TV'               => 'TV',
 // modules/tv/recorded.php
-    'No matching programs found.'             => '',
-    'Showing all programs from the $1 group.' => '',
-    'Showing all programs.'                   => '',
+    'No matching programs found.'             => 'Geen overeenkomsten gevonden',
+    'Showing all programs from the $1 group.' => 'Alle programma\'s uit de $1 groep laten zien',
+    'Showing all programs.'                   => 'Alle programma\'s laten zien',
 // modules/tv/schedules_custom.php
-    'Any Category'                               => '',
-    'Any Channel'                                => '',
-    'Any Program Type'                           => '',
-    'Find Time must be of the format:  HH:MM:SS' => '',
+    'Any Category'                               => 'Alle categorien',
+    'Any Channel'                                => 'Alle zenders',
+    'Any Program Type'                           => 'Alle programmatypes',
+    'Find Time must be of the format:  HH:MM:SS' => 'Tijd moet in het formaat: HH:MM:SS zijn',
 // modules/tv/schedules_manual.php
-    'Use callsign'  => '',
-    'Use date/time' => '',
+    'Use callsign'  => 'Zender gebruiken',
+    'Use date/time' => 'Datum/tijd gebruiken',
 // modules/tv/search.php
-    'Please search for something.' => '',
+    'Please search for something.' => 'Graag iets zoeken.',
 // modules/video/init.php
-    'Video' => '',
+    'Video' => 'Films',
 // themes/default/backend_log/welcome.php
-    'welcome: backend_log' => '',
+    'welcome: backend_log' => 'Logboek laten zien',
 // themes/default/header.php
     'Category Legend'                            => 'Categorie Legende',
     'Category Type'                              => 'Categorie Type',
-    'Custom'                                     => '',
-    'Edit MythWeb and some MythTV settings.'     => 'Bewerk MythWeb en enkele MythTV instellingen',
+    'Custom'                                     => 'Geavanceerd',
+    'Edit MythWeb and some MythTV settings.'     => 'MythWeb en enkele MythTV instellingen bewerken',
     'Exact Match'                                => 'Exacte Overeenkomst',
-    'HD Only'                                    => '',
-    'Manual'                                     => '',
+    'HD Only'                                    => 'Enkel HD',
+    'Manual'                                     => 'Manueel',
     'MythMusic on the web.'                      => 'Muziek',
     'MythVideo on the web.'                      => 'Video',
     'MythWeb Weather.'                           => 'Weer',
@@ -239,85 +239,85 @@
     'Search help: movie search'                  => 'zoek films',
     'Search help: regex example'                 => '/^Good Eats/',
     'Search help: regex search'                  => 'regex zoeken',
-    'Search options'                             => 'Zoek Opties',
-    'Searches'                                   => '',
+    'Search options'                             => 'Zoeken Opties',
+    'Searches'                                   => 'Zoekopdrachten',
     'TV functions, including recorded programs.' => 'TV functies, inclusief opgenomen programma\'s',
 // themes/default/movietimes/welcome.php
-    'welcome: movietimes' => '',
+    'welcome: movietimes' => 'De filmtijden voor uw lokale bioscoop',
 // themes/default/music/music.php
-    'Album'               => '',
-    'Album (filtered)'    => '',
-    'All Music'           => '',
-    'Artist'              => '',
-    'Artist (filtered)'   => '',
-    'Displaying'          => '',
-    'Duration'            => '',
-    'End'                 => '',
-    'Filtered'            => '',
-    'Genre'               => '',
-    'Genre (filtered)'    => '',
-    'Next'                => '',
-    'No Tracks Available' => '',
-    'Previous'            => '',
-    'Top'                 => '',
-    'Track Name'          => '',
-    'Unfiltered'          => '',
+    'Album'               => 'Album',
+    'Album (filtered)'    => 'Album (filter)',
+    'All Music'           => 'Alle muziek',
+    'Artist'              => 'Artiest',
+    'Artist (filtered)'   => 'Artiest (filter)',
+    'Displaying'          => 'Zichtbaar',
+    'Duration'            => 'Lengte',
+    'End'                 => 'Einde',
+    'Filtered'            => 'Met filter',
+    'Genre'               => 'Genre',
+    'Genre (filtered)'    => 'Genre (filter)',
+    'Next'                => 'Volgende',
+    'No Tracks Available' => 'Geen nummers gevonden',
+    'Previous'            => 'Vorige',
+    'Top'                 => 'Begin',
+    'Track Name'          => 'Naam',
+    'Unfiltered'          => 'Zonder filter',
 // themes/default/music/welcome.php
-    'welcome: music' => '',
+    'welcome: music' => 'Doorheen uw muziekcollectie bladeren',
 // themes/default/settings/channels.php
-    'Configure Channels'                                                                                                                 => '',
+    'Configure Channels'                                                                                                                 => 'Zenders instellen',
     'Please be warned that by altering this table without knowing what you are doing, you could seriously disrupt mythtv functionality.' => 'Waarschuwing! Als u niet weet wat u doet, kan het veranderen van deze tabel de werking van MythTV ernstig verstoren.',
-    'brightness'                                                                                                                         => '',
-    'callsign'                                                                                                                           => '',
-    'colour'                                                                                                                             => '',
-    'commfree'                                                                                                                           => '',
-    'contrast'                                                                                                                           => '',
-    'delete'                                                                                                                             => '',
-    'finetune'                                                                                                                           => '',
-    'freqid'                                                                                                                             => '',
-    'hue'                                                                                                                                => '',
-    'name'                                                                                                                               => '',
-    'sourceid'                                                                                                                           => '',
-    'useonairguide'                                                                                                                      => '',
-    'videofilters'                                                                                                                       => '',
-    'visible'                                                                                                                            => '',
-    'xmltvid'                                                                                                                            => '',
+    'brightness'                                                                                                                         => 'helderheid',
+    'callsign'                                                                                                                           => 'zender',
+    'colour'                                                                                                                             => 'kleur',
+    'commfree'                                                                                                                           => 'reclamevrij',
+    'contrast'                                                                                                                           => 'contrast',
+    'delete'                                                                                                                             => 'verwijderen',
+    'finetune'                                                                                                                           => 'fijn afstemmen',
+    'freqid'                                                                                                                             => 'frequentie',
+    'hue'                                                                                                                                => 'verzadiging',
+    'name'                                                                                                                               => 'naam',
+    'sourceid'                                                                                                                           => 'bron',
+    'useonairguide'                                                                                                                      => 'gebruikepg',
+    'videofilters'                                                                                                                       => 'videofilters',
+    'visible'                                                                                                                            => 'zichtbaar',
+    'xmltvid'                                                                                                                            => 'xmltvid',
 // themes/default/settings/keys.php
-    'Action'                => '',
-    'Configure Keybindings' => '',
-    'Context'               => '',
-    'Destination'           => '',
-    'Edit keybindings on'   => 'Bewerk toetsbindingen op',
-    'JumpPoints Editor'     => '',
-    'Key bindings'          => '',
-    'Keybindings Editor'    => '',
-    'Set Host'              => '',
+    'Action'                => 'Actie',
+    'Configure Keybindings' => 'Toetsbindingen instellen',
+    'Context'               => 'Onderdeel',
+    'Destination'           => 'Bestemming',
+    'Edit keybindings on'   => 'Toetsbindingen bewerken op',
+    'JumpPoints Editor'     => 'Snelkoppelingen bewerken',
+    'Key bindings'          => 'Toetsbindingen',
+    'Keybindings Editor'    => 'Toetsbindingen bewerken',
+    'Set Host'              => 'Host instellen',
 // themes/default/settings/session.php
     'Channel &quot;Jump to&quot;'     => 'Zender &quot;Ga naar&quot;',
     'Date Formats'                    => 'Weergave Datum',
-    'Guide Settings'                  => '',
+    'Guide Settings'                  => 'Gidsinstellingen',
     'Hour Format'                     => 'Weergave Tijd',
     'Language'                        => 'Taal',
     'Listing &quot;Jump to&quot;'     => 'Gids &quot;Ga naar&quot;',
     'Listing Time Key'                => 'Weergave Tijd Gids',
-    'MythWeb Session Settings'        => '',
+    'MythWeb Session Settings'        => 'MythWen Sessie Instellingen',
     'MythWeb Theme'                   => 'MythWeb Thema',
-    'Only display favourite channels' => '',
+    'Only display favourite channels' => 'Enkel favoriete zenders laten zien',
     'Reset'                           => 'Herstellen',
-    'SI Units?'                       => '',
-    'Scheduled Popup'                 => 'Geprogrammeerd Pop-up',
-    'Show descriptions on new line'   => 'Toon beschrijvingen op nieuwe regel',
+    'SI Units?'                       => 'SI eenheden?',
+    'Scheduled Popup'                 => 'Geprogrammeerde Pop-up',
+    'Show descriptions on new line'   => 'Beschrijvingen op nieuwe regel',
     'Status Bar'                      => 'Statusbalk',
-    'Weather Icons'                   => '',
+    'Weather Icons'                   => 'Weer iconen',
     'format help'                     => 'formaat help',
 // themes/default/settings/settings.php
     'settings: overview' => 'instellingen: overzicht',
 // themes/default/settings/welcome.php
-    'welcome: settings' => '',
+    'welcome: settings' => 'MythWeb en enkele MythTV instellingen bewerken',
 // themes/default/status/welcome.php
-    'welcome: status' => '',
+    'welcome: status' => 'MythTV Logboek',
 // themes/default/tv/channel.php
-    'Channel Detail' => '',
+    'Channel Detail' => 'Zender detail',
     'Length'         => 'Duur',
     'Show'           => 'Toon',
     'Time'           => 'Tijd',
@@ -327,42 +327,42 @@
     'Cast'                                => 'Acteurs',
     'Directed by'                         => 'Regisseur',
     'Don\'t record this program.'         => 'Dit programma niet opnemen',
-    'Episode Number'                      => '',
+    'Episode Number'                      => 'Aflevering nr.',
     'Exec. Producer'                      => 'Uitv. Producent',
-    'Find other showings of this program' => 'Vind andere afleveringen van dit programma',
-    'Find showings of this program'       => 'Vind afleveringen van dit programma',
+    'Find other showings of this program' => 'Andere afleveringen van dit programma zoeken',
+    'Find showings of this program'       => 'Afleveringen van dit programma zoeken',
     'Google'                              => 'Google',
-    'Guest Starring'                      => '',
-    'Guide rating'                        => '',
+    'Guest Starring'                      => 'Gastrol',
+    'Guide rating'                        => 'Gids beoordeling',
     'Hosted by'                           => '',
-    'MythTV Status'                       => '',
-    'Possible conflicts with this show'   => '',
+    'MythTV Status'                       => 'MythTV status',
+    'Possible conflicts with this show'   => 'Mogelijk conflict met dit programma',
     'Presented by'                        => 'Presentator',
     'Produced by'                         => 'Producent',
-    'Program Detail'                      => '',
-    'Program ID'                          => '',
-    'TV.com'                              => '',
-    'Time Stretch Default'                => '',
-    'What else is on at this time?'       => 'Wat wordt er nog uitgezonden op dit tijdstip',
+    'Program Detail'                      => 'Pragrammadetails',
+    'Program ID'                          => 'Programma ID',
+    'TV.com'                              => 'TV.com',
+    'Time Stretch Default'                => 'TimeStretch Standaard',
+    'What else is on at this time?'       => 'Wat wordt er nog uitgezonden op dit tijdstip?',
     'Written by'                          => 'Auteur',
 // themes/default/tv/list.php
     'Jump To' => 'Ga naar',
 // themes/default/tv/list_cell_nodata.php
-    'NO DATA' => '',
+    'NO DATA' => 'GEEN DATA',
 // themes/default/tv/recorded.php
     '$1 episode'                                          => '$1 aflevering',
     '$1 episodes'                                         => '$1 afleveringen',
     '$1 recording'                                        => '$1 opname',
     '$1 recordings'                                       => '$1 opnames',
-    'All groups'                                          => '',
+    'All groups'                                          => 'Alle groepen',
     'Are you sure you want to delete the following show?' => 'Bent U zeker van het verwijderen van volgend programma?',
     'Delete'                                              => 'Verwijderen',
-    'Delete $1'                                           => '',
-    'Delete + Rerecord'                                   => '',
-    'Delete and rerecord $1'                              => '',
+    'Delete $1'                                           => '$1 verwijderen',
+    'Delete + Rerecord'                                   => 'Verwijderen en opnieuw opnemen',
+    'Delete and rerecord $1'                              => 'Verwijderen en $1 opnieuw opnemen',
     'Go'                                                  => 'Doorgaan',
-    'Show group'                                          => 'Toon groep',
-    'Show recordings'                                     => 'Toon opnames',
+    'Show group'                                          => 'Groep tonen',
+    'Show recordings'                                     => 'Opnames tonen',
     'auto-expire'                                         => 'automatisch vervallen',
     'file size'                                           => 'bestandsgrootte',
     'has bookmark'                                        => 'heeft index',
@@ -375,19 +375,19 @@
     'No recording schedules have been defined.' => 'Er zijn geen opnameschema\'s gevonden.',
     'channel'                                   => 'zender',
     'profile'                                   => 'profiel',
-    'transcoder'                                => '',
+    'transcoder'                                => 'transcoder',
     'type'                                      => 'type',
 // themes/default/tv/schedules_custom.php
-    'Additional Tables'        => '',
-    'Find Date & Time Options' => '',
-    'Find Day'                 => '',
-    'Find Time'                => '',
-    'Keyword Search'           => '',
-    'People Search'            => '',
-    'Power Search'             => '',
-    'Search Phrase'            => '',
-    'Search Type'              => '',
-    'Title Search'             => '',
+    'Additional Tables'        => 'Aanvullende tabellen',
+    'Find Date & Time Options' => 'Datum &amp; tijd zoeken, opties',
+    'Find Day'                 => 'Dag zoeken',
+    'Find Time'                => 'Tijd zoeken',
+    'Keyword Search'           => 'Kernwoord zoeken',
+    'People Search'            => 'Personen zoeken',
+    'Power Search'             => 'Geavanceerd zoeken',
+    'Search Phrase'            => 'Zin zoeken',
+    'Search Type'              => 'Type zoeken',
+    'Title Search'             => 'Titel zoeken',
 // themes/default/tv/schedules_manual.php
     'Channel'      => 'Zender',
     'Length (min)' => 'Duur (min)',
@@ -395,11 +395,11 @@
     'Start Time'   => 'Start Tijd',
 // themes/default/tv/search.php
     'No matches found'                 => 'Geen programma\'s gevonden',
-    'No matching programs were found.' => '',
-    'Search for:  $1'                  => '',
+    'No matching programs were found.' => 'Geen overeenkomende programma\'s gevonden',
+    'Search for:  $1'                  => 'Zoeken: $1',
 // themes/default/tv/searches.php
-    'Handy Predefined Searches' => '',
-    'handy: overview'           => '',
+    'Handy Predefined Searches' => 'Handige voorgeprogrammeerde zoekopdrachten',
+    'handy: overview'           => 'Deze pagina bevat handige voorgeprogrammeerde complexe zoekopdrachten',
 // themes/default/tv/upcoming.php
     'Commands'    => 'Opdrachten',
     'Conflicts'   => 'Conflicten',
@@ -407,20 +407,20 @@
     'Duplicates'  => 'Dubbels',
     'Scheduled'   => 'Geprogrammeerd',
 // themes/default/tv/welcome.php
-    'welcome: tv' => '',
+    'welcome: tv' => 'Laten zien wat er op TV is, opnames plannen en opgenomen programma\'s beheren. Keuze uit de volgende items:',
 // themes/default/video/video.php
-    'Edit'          => '',
-    'Reverse Order' => '',
-    'Videos'        => '',
-    'category'      => '',
-    'cover'         => '',
-    'director'      => '',
-    'imdb rating'   => '',
-    'plot'          => '',
-    'rating'        => '',
-    'year'          => '',
+    'Edit'          => 'Bewerken',
+    'Reverse Order' => 'Volgorde omkeren',
+    'Videos'        => 'Films',
+    'category'      => 'categorie',
+    'cover'         => 'hoes',
+    'director'      => 'regisseur',
+    'imdb rating'   => 'imdb beoordeling',
+    'plot'          => 'korte inhoud',
+    'rating'        => 'beoordeling',
+    'year'          => 'jaar',
 // themes/default/video/welcome.php
-    'welcome: video' => '',
+    'welcome: video' => 'Doorheen uw filmcollectie bladeren.',
 // themes/default/weather/weather.php
     ' at '               => ' aan ',
     'Current Conditions' => 'Huidige Waarnemingen',
@@ -442,7 +442,7 @@
     'Wind'               => 'Wind',
     'Wind Chill'         => 'Voeltemp. Wind',
 // themes/default/weather/welcome.php
-    'welcome: weather' => ''
+    'welcome: weather' => 'Uw lokale weerbericht'
 // End of the translation hash ** Do not touch the next line
           );
 